Introduction
============

Description
-----------
Persimmon is a visual programming interface for sklearn.

This projects touches on a variety of CS topics, such as User Experience (Main 
topic as the project is driven by the users feedback and engagement with the
project), Software Engineering (We have to interact with already built software,
using interfaces and organizing code through object-oriented techniques), 
Compilers (Language parsing and transpilers) and a number of tangentially 
related topics such as Machine Learning, I/O, preprocessing, etc.

Motivation
----------
After learning about Machine Learning this past year I was able to win a 
Kaggle like [^1] competition and got an internship working for a company on the
algorithmic trading sector.

There, amongst other duties, I aided with moving the codebase from MATLAB to 
Python, and during that process I realised many of my co-workers struggled with
the move, as they were not computer scientists, but came from a variety of
backgrounds such as Maths, Physics, Electric Engineering, Statistics, etc...

Yet they were the whole of the department, as this topic requires a high level 
of theoretical maths knowledge, and so happens that these subjects tend to not
have a lot of general programming skills, they mostly work with specialized 
languages, tailored to these tasks such as MATLAB, R, Julia, etc, and moving to
a general purpose language such as Python involves learning about a plethora of 
additional topics.

The situation is even more complicated for newcomers to Machine Learning from 
these backgrounds, as they not only have the programming barrier but also have
to overcome the difficulties of the algorithms themselves, something Computer 
Scientists also struggle with (In many cases even more because their weaker 
maths skills)

So this project servers a double purpose, it helps with the programming barrier,
and it aids with the Machine Learning process as it allows the learner to focus
on the connections, intuitions and mathematical basis and not on the 
implementation details and the quirks of the concrete language.

[^1]: [Kaggle.com](https://www.kaggle.com/)
